<?php

/* TODO: CHANGE THE SECRET KEY */
$supa_secret_key = "/!\\ CHANGEME /!\\";

function decode_cookie($cookie)
{
    global $supa_secret_key;

    $cookie = base64_decode($cookie);
    $iv = substr($cookie, 0, 16);
    $encrypted = substr($cookie, 16);

    if ((strlen($iv) < 16) || (strlen($encrypted) % 16 != 0))
    {
        return array(
            'email' => 'e-mail',
            'coupon' => 'coupon',
            'invalid_coupon' => false,
            'quantity' => 1
        );
    }

    $decrypted = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $supa_secret_key, $encrypted, MCRYPT_MODE_CBC, $iv);
    if (strpos($decrypted, "\x00") !== FALSE)
        $decrypted = substr($decrypted, 0, strpos($decrypted, "\x00"));

    $values =  json_decode($decrypted, true);
    if (json_last_error() !== JSON_ERROR_NONE)
    {
        return array(
            'email' => 'e-mail',
            'coupon' => 'coupon',
            'invalid_coupon' => false,
            'quantity' => 1
        );
    }
    return $values;
}

function encode_cookie($infos)
{
    global $supa_secret_key;

    $json = json_encode($infos);
    $iv = mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC), MCRYPT_RAND);
    $encrypted = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $supa_secret_key, $json, MCRYPT_MODE_CBC, $iv);
    return base64_encode($iv . $encrypted);
}
?> 

<!DOCTYPE html>
<html>
<head>
<meta name="author" content="Eloi Vanderbeken - Synacktiv - @elvanderb">
<meta name="contact" content="eloi.vanderbeken@synacktiv.com" />
<meta name="description" content="Choucroute as a Service" />
<meta name="keywords" content="choucroute, paté, reblochon">
<link rel="stylesheet" href="hopa_choucroute_style.css">
</head>
<body>
<?php if (isset($_GET['go'])) { 
    $values = decode_cookie($_COOKIE['bucket']);
    ?>
    <form name="wurst" method=post action="index.php">
    <input type="hidden" name="continue">
    <div class="table">
    <table>
    <tr><td class="description">e-mail address:<td class="content"><input type="text" name="email" value="<?php if (isset($values['email'])) { echo htmlentities($values['email']); } ?>" placeholder="e-mail"></td></tr>
    <tr><td class="description">coupon code:</td><td class="content"><input type="text" name="coupon" value="<?php if (isset($values['coupon'])) { echo htmlentities($values['coupon']); } ?>" placeholder="<?php if ($values['invalid_coupon']) { echo 'invalid coupon'; } else { echo 'coupon'; } ?>"></td></tr>
    <tr><td class="description">quantity:</td><td class="content"><select name="quantity">
    <?php for ($i = 1; $i <= 5; $i++) {
        echo '<option value="'.$i.'" ' . ($values['quantity'] == $i ? 'selected' : '') . '>' . $i . '</option>';
    } ?>
    </select></td></tr>
    <tr><td colspan="2" ><button type="submit" style="border: 0; background: transparent"><img src="next.png" width="150px"/></button></td></tr>
    </table>
	</div>
    </form>

<?php } elseif (isset($_POST['continue'])) {
    $cookie = array(
        'email' => $_POST['email'],
        'coupon' => $_POST['coupon'],
        'quantity' => $_POST['quantity']
    );
    $encrypted = encode_cookie($cookie);

    $quantity = intval($_POST['quantity'], 10);
    if (($quantity < 1) || ($quantity > 5))
    {
        setcookie('bucket', $encrypted);
    	die('<script type="text/javascript">window.location.href="index.php?go";</script>');
    }
    if (! isset($_POST['email']))
    {
        setcookie('bucket', $encrypted);
    	die('<script type="text/javascript">window.location.href="index.php?go";</script>');
    }

    $price = 14.99 * $quantity;
    $reduction = 0;
    if (isset($_POST['coupon']) && (strlen($_POST['coupon']) > 0))
    {
        switch ($_POST['coupon']) {
            case 'CONCHITAWURST':
                $reduction = 1;
                break;
            case 'ENORMESAUCISSE':
                $reduction = 1.5;
                break;
            case 'GROLARDEOVER' :
                $reduction = 0.25;
                break;
            default:
                $cookie['coupon'] = '';
                $cookie['invalid_coupon'] = true;
                $encrypted = encode_cookie($cookie);
                setcookie('bucket', $encrypted);
    			die('<script type="text/javascript">window.location.href="index.php?go";</script>');
        }
    }
    $cookie['to_pay'] = $price - $reduction;
    $cookie['security_check'] = hash('md5', $quantity . '|' .  ($price - $reduction));
    $encrypted = encode_cookie($cookie);
    setcookie('bucket', $encrypted);
	?>
    <form name="fatback" method=post action="index.php">
    <div class="table">
    <table>
    <tr><td class="description">price:</td><td class="content"><?php echo $price; ?> &#8364</td></tr>
    <tr><td class="description">reduction:</td><td class="content"><?php echo $reduction; ?> &#8364</td></tr>
    <tr><td class="description">total:</td><td class="content"><?php echo $price - $reduction; ?> &#8364</td></tr>
    <input type="hidden" name="buy">
    <tr><TD><a href="index.php?go"><img src="back.png" width="150px"/></a></TD><td><button type="submit"><img src="buy.png"  width="150px"/></button></td></tr>
    </table>
	</div>
    </form>

<?php } elseif (isset($_POST['buy'])) {
    $values = decode_cookie($_COOKIE['bucket']);
    if ((! isset($values['to_pay'])) || (! isset($values['security_check'])) || (! isset($values['quantity'])))
    	die('<script type="text/javascript">window.location.href="index.php?go";</script>');

    $to_pay = $values['to_pay'];
    $quantity = $values['quantity'];
    if (hash('md5', $quantity . '|' .  $to_pay) !== $values['security_check'])
    	die('<script type="text/javascript">window.location.href="index.php?go";</script>');

    if ($to_pay > 0) {
        echo "\n\n<p>HANDLE PAYMENT</p>\n\n";
    } else {
        echo "\n\n<p>SEND CHOUCROUTE</p>\n\n";
	}?>
<?php } else { ?>
	<div class="table">
	<table>
	<TR><TD class="title"><h1>Welcome to Super Choucroute</h2></TD></TR>
    <TR><TD class="title"><a href="index.php?go"><img src="do_want.png" width="300px"/></a></TD></TR>
	<TR><TD class="title"><h3>The World's FIRST CaaS* Provider!</h3></TD></TR>
	</table>
    <p class="note">*Choucroute as a Service</p>
	</div>

<?php } ?>
</body>
</html>
